"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAuthAttribute = exports.updateAuthAttribute = exports.setAuthAttribute = exports.deleteAuthAttributes = exports.setAuthTokens = void 0;
const toolkit_1 = require("@reduxjs/toolkit");
const date_fns_1 = require("date-fns");
const types_1 = require("./types");
const initialState = {
    authenticated: undefined,
    accessToken: undefined,
    refreshToken: undefined,
    idToken: undefined,
    accessExpiresIn: undefined,
    refreshExpiresIn: undefined,
    accessExpiresTime: undefined,
    refreshExpiresTime: undefined,
    sessionState: undefined,
};
const authSlice = (0, toolkit_1.createSlice)({
    name: types_1.AUTH_REDUCER_NAME,
    initialState,
    reducers: {
        setAuthTokens: (_, action) => {
            const { accessExpiresIn, refreshExpiresIn } = action.payload;
            return Object.assign(Object.assign(Object.assign(Object.assign({}, action.payload), (accessExpiresIn ? { accessExpiresTime: (0, date_fns_1.addSeconds)(new Date(), accessExpiresIn).toISOString() } : {})), (refreshExpiresIn ? { refreshExpiresTime: (0, date_fns_1.addSeconds)(new Date(), refreshExpiresIn).toISOString() } : {})), { authenticated: true });
        },
        setAuthAttribute: (state, action) => {
            return Object.assign(Object.assign({}, state), action.payload);
        },
        updateAuthAttribute: (state, action) => {
            state[action.payload.key] = action.payload.value;
        },
        deleteAuthAttributes: () => {
            return {};
        },
    },
});
_a = authSlice.actions, exports.setAuthTokens = _a.setAuthTokens, exports.deleteAuthAttributes = _a.deleteAuthAttributes;
exports.setAuthAttribute = authSlice.actions.setAuthAttribute;
exports.updateAuthAttribute = authSlice.actions.updateAuthAttribute;
const getAuthAttribute = (state, name) => state.procyon.auth[name];
exports.getAuthAttribute = getAuthAttribute;
exports.default = authSlice.reducer;
